/*

 * WordPress Security Lab

 * (c) 2013

 */





jQuery(document).ready(function($){

  // alternate table rows

  $('#sn-tests-help tr:odd, #security-ninja tr:odd').addClass('alternate');



  // init tabs

  $("#tabs").tabs({cookie:{expires: 30}});



  // just to make sure the button is not stuck

  $('#run-tests').removeAttr('disabled');



  // run tests, via ajax

  $('#run-tests').click(function(){

    var data = {action: 'wpsl_run_tests'};



    $(this).attr('disabled', 'disabled')

           .val('Running tests, please wait!');

    $.blockUI({ message: 'WordPress Security Lab is analyzing your site.<br />Please wait, it can take a few minutes.' });



    $.post(ajaxurl, data, function(response) {

      if (response != '1') {

        alert('Undocumented error. Page will automatically reload.');

        window.location.reload();

      } else {

        window.location.reload();

      }

    });

  }); // run tests



  // show test details/help tab

  $('.sn-details a.details').live('click', function(){

    if ($('#wf-ss-dialog').length){

      $('#wf-ss-dialog').dialog('close');

    }

    $("#tabs").tabs('select', '#sn_help');



    // get the link anchor and scroll to it

    target = this.href.split("#")[1];

    $.scrollTo('#' + target, 500, {offset: {top:-30, left:0}});



    return false;

  }); // show test details



  // fixit action

  $('.sn-details a.fixit').live('click', function(){

    var data = {action: 'wpsl_fixit', test: $(this).attr('data-test')};



    $.blockUI({ message: 'WordPress Security Lab is applying the fix.<br />Please wait, it can take a few minutes.' });

    $.post(ajaxurl, data, function(response) {

      $.unblockUI();

      if (response == '10') {

        alert('Fix successfully applied! Tests will now be automatically rerun.');

        $('#run-tests').trigger('click');

      } else {

        alert('Unable to apply the fix. Please contact us vie email - support@wordpresssecuritylab.com');

      }

    });



    return false;

  });



  // hide core add-on tab

  $('#helpme').click(function(){

    $('#helpme-dialog').dialog('open');

  });



  $('#helpme-do').click(function() {

    var data = {action: 'wpsl_helpme', details: $('#helpme-details').val()};



    $.post(ajaxurl, data, function(response) {

      if (response != '0') {

        alert('Support request has been sent! We\'ll get back to you ASAP!');

        $('#helpme-dialog').dialog('close');

      } else {

        alert('Undocumented error. Please contact us vie email - support@wordpresssecuritylab.com');

      }

    });

  });



  $('#helpme-dialog').dialog({

    autoOpen: false,

    dialogClass: 'wp-dialog',

    modal: true,

    width: '350px',

    title: 'Ask for Assistance from a WP Security Expert',

    open: function(){ close_dialog = 1; },

    buttonsx: [{ text: 'Save', 'class': 'button-primary',

      'click': function() {

          $('#redirect-err').hide();

          var data = {action:        'ln_new_ban_save',

                      ip:       $('#ip').val(),

                      ban_time: $('#ban_time').val()};



          jQuery.post(ajaxurl, data, function(response) {

            if (response != '1') {

              $('#redirect-err').html(response).show();

            } else {

              alert('New ban has been added.');

              $('#wf-dialog-ban').dialog("close");

              window.location.reload();

            }

          });

        }},

      { text: 'Cancel', 'class': 'button-secondary',

      'click': function() {

          $('.ui-widget-overlay').unbind('click');

          $(this).dialog("close");

          $('#wf-dialog-ban').empty();

        }

      }]

  }); /// dialog

}); // onload